#[derive(Debug)]
enum List1 {
    Cons1(i32, Box<List1>),
    Nil1
}

use crate::List1::{Cons1, Nil1};

#[derive(Debug)]
enum List2 {
    Cons2(i32, Rc<List2>),
    Nil2
}

use crate::List2::{Cons2, Nil2};
use std::rc::Rc;

fn main() {
    let a: List1 = Cons1(5,
        Box::new(Cons1(10,
            Box::new(Nil1))));

    let b: List1 = Cons1(1, Box::new(a));
    // let c: List1 = Cons(2,Box::new(a));  // 发生借用

    println!("{:?}", b);

    // Rc<T>
    let a = Rc::new(Cons2(1,
        Rc::new(Cons2(2,
            Rc::new(Nil2)))));
    let b = Cons2(3, Rc::clone(&a));
    let c = Cons2(4, Rc::clone(&a));
    println!("{:?}, {:?}, {:?}, {:?}", a, b, c, Rc::strong_count(&a));
}
